package dao

import org.jetbrains.exposed.dao.IntEntity
import org.jetbrains.exposed.dao.IntEntityClass
import org.jetbrains.exposed.dao.id.EntityID
import org.jetbrains.exposed.dao.id.IntIdTable

object Items : IntIdTable("ItemsV2") {
    val list = integer("list")
    val content = varchar("content", 256)
    val position = integer("position").nullable()
    val checked = bool("checked").default(false)
}

class Item(id: EntityID<Int>) : IntEntity(id) {
    companion object : IntEntityClass<Item>(Items)

    var list by Items.list
    var content by Items.content
    var position by Items.position
    var checked by Items.checked


}
fun Item.toView(): ItemView {
    return ItemView(this.id.value, this.content, this.checked, this.position)
}

data class ItemView(val id: Int, val content: String, val checked: Boolean = false, val position: Int?)

data class ItemPatchView(val id: Int, val content: String?, val checked: Boolean?, val position: Int?)